#include "DS18B20.h"
#include "1wire.h"

#define DS18B20_CONVERT_T 0x44
#define DS18B20_READ_SCRATCHPAD 0xBE

void getTemperature(float * temperature) {
	static enum TemperatureState temperatureState = TEMP_IDLE;
	switch (temperatureState) {
		case TEMP_IDLE:
		oneWireReset();
		oneWireSendByte(OW_SKIP_ROM);
		oneWireSendByte(DS18B20_CONVERT_T);
		temperatureState = TEMP_IN_PROGRESS;
		break;
		case TEMP_IN_PROGRESS:
		if (oneWireReceiveBit()) temperatureState = TEMP_READY;
		break;
		case TEMP_READY:
		oneWireReset();
		oneWireSendByte(OW_SKIP_ROM);
		oneWireSendByte(DS18B20_READ_SCRATCHPAD);
		int16_t temp;
		uint8_t * byte = (uint8_t *) &temp;
		byte[0] = oneWireReceiveByte();
		byte[1] = oneWireReceiveByte();
		*temperature = temp / 16.0;
		temperatureState = TEMP_IDLE;
		break;
	}
}